﻿using System.Collections.Immutable;
using Connected.Security.Permissions;

namespace Connected.Security.Authorization.Middleware;

public enum AuthorizationProviderResult
{
	Success = 1,
	Fail = 2,
	NotHandled = 3
}
public interface IAuthorizationMiddleware : IMiddleware
{
	string Id { get; }
	Task<AuthorizationProviderResult> PreAuthorize(AuthorizationArgs args, Dictionary<string, object> state);
	Task<AuthorizationProviderResult> Authorize(IPermission permission, AuthorizationArgs args, Dictionary<string, object> state);
	Task<ImmutableList<IPermissionSchemaDescriptor>> QueryDescriptors();
}
